diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/rate-control/rrpaa-wifi-manager.h ns-3.34/src/wifi/model/rate-control/rrpaa-wifi-manager.h
--- ns-3.33/src/wifi/model/rate-control/rrpaa-wifi-manager.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/rate-control/rrpaa-wifi-manager.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,237 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2017 Universidad de la República - Uruguay
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Matías Richart <mrichart@fing.edu.uy>
+ */
+
+#ifndef RRPAA_WIFI_MANAGER_H
+#define RRPAA_WIFI_MANAGER_H
+
+#include "ns3/nstime.h"
+#include "ns3/random-variable-stream.h"
+#include "ns3/wifi-remote-station-manager.h"
+
+namespace ns3 {
+
+struct RrpaaWifiRemoteStation;
+
+/**
+ * \ingroup wifi
+ * Robust Rate and Power Adaptation Algorithm
+ *
+ * This class implements the RRPAA algorithm as described in <i>Rate, Power and Carrier-Sense
+ * Threshold Coordinated Management for High-Density IEEE 802.11 Networks</i>
+ * by Matías Richart; Jorge Visca and Javier Baliosian in Integrated Network Management (IM),
+ * 2015 IFIP/IEEE International Symposium on (pp. 139-146). IEEE.
+ * http://dl.ifip.org/db/conf/im/im2015/137430.pdf
+ *
+ * RRPAA adds power control to the RRAA mechanism. RRAA is described in
+ * <i>Robust rate adaptation for 802.11 wireless networks</i> by Starsky H. Y. Wong;
+ * Hao Yang; Songwu Lu and Vaduvur Bharghavan in Proceedings of the 12th annual
+ * international conference on Mobile computing and networking (pp. 146-157). ACM.
+ * http://ocw.cs.pub.ro/courses/_media/isrm/articole/rrate_adapt_mobicom06.pdf
+ *
+ * This RAA does not support HT modes and will error
+ * exit if the user tries to configure this RAA with a Wi-Fi MAC
+ * that supports 802.11n or higher.
+ */
+
+/**
+ * For each rate there is a Opportunistic Rate Increase threshold,
+ * a Maximum Tolerable Loss threshold and an Evaluation Window.
+ */
+struct WifiRrpaaThresholds
+{
+  double m_ori; //!< The Opportunistic Rate Increase threshold.
+  double m_mtl; //!< The Maximum Tolerable Loss threshold.
+  uint32_t m_ewnd; //!< The Estimation Window size.
+};
+
+/**
+ * List of thresholds for each mode.
+ */
+typedef std::vector<std::pair<WifiRrpaaThresholds,WifiMode> > RrpaaThresholdsTable;
+
+/**
+ * List of probabilities.
+ */
+typedef std::vector<std::vector<double> > RrpaaProbabilitiesTable;
+
+class RrpaaWifiManager : public WifiRemoteStationManager
+{
+public:
+  /**
+   * Register this type.
+   * \return The object TypeId.
+   */
+  static TypeId GetTypeId (void);
+  RrpaaWifiManager ();
+  virtual ~RrpaaWifiManager ();
+
+  void SetupPhy (const Ptr<WifiPhy> phy) override;
+  void SetupMac (const Ptr<WifiMac> mac) override;
+
+  /**
+   * Assign a fixed random variable stream number to the random variables
+   * used by this model.  Return the number of streams (possibly zero) that
+   * have been assigned.
+   *
+   * \param stream first stream index to use
+   *
+   * \return the number of stream indices assigned by this model
+   */
+  int64_t AssignStreams (int64_t stream) override;
+
+private:
+  void DoInitialize (void) override;
+  WifiRemoteStation * DoCreateStation (void) const override;
+  void DoReportRxOk (WifiRemoteStation *station,
+                     double rxSnr, WifiMode txMode) override;
+  void DoReportRtsFailed (WifiRemoteStation *station) override;
+  void DoReportDataFailed (WifiRemoteStation *station) override;
+  void DoReportRtsOk (WifiRemoteStation *station,
+                      double ctsSnr, WifiMode ctsMode, double rtsSnr) override;
+  void DoReportDataOk (WifiRemoteStation *station, double ackSnr, WifiMode ackMode,
+                       double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss) override;
+  void DoReportFinalRtsFailed (WifiRemoteStation *station) override;
+  void DoReportFinalDataFailed (WifiRemoteStation *station) override;
+  WifiTxVector DoGetDataTxVector (WifiRemoteStation *station) override;
+  WifiTxVector DoGetRtsTxVector (WifiRemoteStation *station) override;
+  bool DoNeedRts (WifiRemoteStation *st,
+                  uint32_t size, bool normally) override;
+
+  /**
+   * Check for initializations.
+   * \param station the remote station.
+   */
+  void CheckInit (RrpaaWifiRemoteStation *station);
+
+  /**
+   * Check if the counter should be reset.
+   *
+   * \param station the remote station
+   */
+  void CheckTimeout (RrpaaWifiRemoteStation *station);
+  /**
+   * Find an appropriate rate and power for the given station, using
+   * a basic algorithm.
+   *
+   * \param station the remote station
+   */
+  void RunBasicAlgorithm (RrpaaWifiRemoteStation *station);
+  /**
+   * Run an enhanced algorithm which activates the use of RTS
+   * for the given station if the conditions are met.
+   *
+   * \param station the remote station
+   */
+  void RunAdaptiveRtsAlgorithm (RrpaaWifiRemoteStation *station);
+  /**
+   * Reset the counters of the given station.
+   *
+   * \param station the remote station
+   */
+  void ResetCountersBasic (RrpaaWifiRemoteStation *station);
+
+  /**
+   * Initialize the thresholds internal list for the given station.
+   *
+   * \param station the remote station
+   */
+  void InitThresholds (RrpaaWifiRemoteStation *station);
+
+  /**
+   * Get the thresholds for the given station and mode.
+   *
+   * \param station the remote station
+   * \param mode the WifiMode
+   *
+   * \return the RRPAA thresholds
+   */
+  WifiRrpaaThresholds GetThresholds (RrpaaWifiRemoteStation *station, WifiMode mode) const;
+
+  /**
+   * Get the thresholds for the given station and mode index.
+   *
+   * \param station the remote station
+   * \param index the mode index in the supported rates
+   *
+   * \return the RRPAA thresholds
+   */
+  WifiRrpaaThresholds GetThresholds (RrpaaWifiRemoteStation *station, uint8_t index) const;
+
+  /**
+   * Get the estimated TxTime of a packet with a given mode.
+   *
+   * \param mode the WifiMode
+   *
+   * \return the estimated TX time
+   */
+  Time GetCalcTxTime (WifiMode mode) const;
+  /**
+   * Add transmission time for the given mode to an internal list.
+   *
+   * \param mode the WifiMode
+   * \param t transmission time
+   */
+  void AddCalcTxTime (WifiMode mode, Time t);
+
+  /**
+   * typedef for a vector of a pair of Time, WifiMode.
+   * Essentially a list for WifiMode and its corresponding transmission time
+   * to transmit a reference packet.
+   */
+  typedef std::vector<std::pair<Time,WifiMode> > TxTime;
+
+  TxTime m_calcTxTime;     //!< To hold all the calculated TxTime for all modes.
+  Time m_sifs;             //!< Value of SIFS configured in the device.
+  Time m_difs;             //!< Value of DIFS configured in the device.
+
+  uint32_t m_frameLength;  //!< Data frame length used for calculate mode TxTime (in bytes).
+  uint32_t m_ackLength;    //!< Ack frame length used for calculate mode TxTime (in bytes).
+
+  bool m_basic;            //!< If using the basic algorithm (without RTS/CTS).
+  Time m_timeout;          //!< Timeout for the RRAA BASIC loss estimation block.
+  double m_alpha;          //!< Alpha value for RRPAA (value for calculating MTL threshold)
+  double m_beta;           //!< Beta value for RRPAA (value for calculating ORI threshold).
+  double m_tau;            //!< Tau value for RRPAA (value for calculating EWND size).
+  double m_gamma;          //!< Gamma value for RRPAA (value for pdTable decrements).
+  double m_delta;          //!< Delta value for RRPAA (value for pdTable increments).
+
+  /**
+   * Differently form rate, power levels do not depend on the remote station.
+   * The levels depend only on the physical layer of the device.
+   */
+  uint8_t m_minPowerLevel;     //!< Minimal power level.
+  uint8_t m_maxPowerLevel;     //!< Maximal power level.
+  uint8_t m_nPowerLevels;      //!< Number of power levels.
+
+  /**
+   * The trace source fired when the transmission power change
+   */
+  TracedCallback<double, double, Mac48Address> m_powerChange;
+  /**
+   * The trace source fired when the transmission rate change
+   */
+  TracedCallback<DataRate, DataRate, Mac48Address> m_rateChange;
+
+  Ptr<UniformRandomVariable> m_uniformRandomVariable; //!< Provides uniform random variables for probabilistic changes.
+};
+
+} //namespace ns3
+
+#endif /* RRPAA__WIFI_MANAGER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/rate-control/thompson-sampling-wifi-manager.cc ns-3.34/src/wifi/model/rate-control/thompson-sampling-wifi-manager.cc
--- ns-3.33/src/wifi/model/rate-control/thompson-sampling-wifi-manager.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/rate-control/thompson-sampling-wifi-manager.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,415 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2021 IITP RAS
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Alexander Krotov <krotov@iitp.ru>
+ */
+
+#include "ns3/log.h"
+#include "ns3/double.h"
+#include "ns3/core-module.h"
+#include "ns3/packet.h"
+
+#include "ns3/wifi-phy.h"
+
+#include "thompson-sampling-wifi-manager.h"
+
+#include <cstdint>
+#include <cstdlib>
+#include <fstream>
+#include <iostream>
+#include <string>
+
+namespace ns3 {
+
+/**
+ * A structure containing parameters of a single rate and its
+ * statistics.
+ */
+struct RateStats {
+  WifiMode mode; ///< MCS
+  uint16_t channelWidth; ///< channel width in MHz
+  uint8_t nss; ///< Number of spatial streams
+
+  double success{0.0}; ///< averaged number of successful transmissions
+  double fails{0.0}; ///< averaged number of failed transmissions
+  Time lastDecay{0}; ///< last time exponential decay was applied to this rate
+};
+
+/**
+ * Holds station state and collected statistics.
+ *
+ * This struct extends from WifiRemoteStation to hold additional
+ * information required by ThompsonSamplingWifiManager.
+ */
+struct ThompsonSamplingWifiRemoteStation : public WifiRemoteStation
+{
+  size_t m_nextMode; //!< Mode to select for the next transmission
+  size_t m_lastMode; //!< Most recently used mode, used to write statistics
+
+  std::vector<RateStats> m_mcsStats; //!< Collected statistics
+};
+
+NS_OBJECT_ENSURE_REGISTERED (ThompsonSamplingWifiManager);
+
+NS_LOG_COMPONENT_DEFINE ("ThompsonSamplingWifiManager");
+
+TypeId
+ThompsonSamplingWifiManager::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::ThompsonSamplingWifiManager")
+    .SetParent<WifiRemoteStationManager> ()
+    .SetGroupName ("Wifi")
+    .AddConstructor<ThompsonSamplingWifiManager> ()
+    .AddAttribute ("Decay",
+                   "Exponential decay coefficient, Hz; zero is a valid value for static scenarios",
+                   DoubleValue (1.0),
+                   MakeDoubleAccessor (&ThompsonSamplingWifiManager::m_decay),
+                   MakeDoubleChecker<double> (0.0))
+    .AddTraceSource ("Rate",
+                     "Traced value for rate changes (b/s)",
+                     MakeTraceSourceAccessor (&ThompsonSamplingWifiManager::m_currentRate),
+                     "ns3::TracedValueCallback::Uint64")
+  ;
+  return tid;
+}
+
+ThompsonSamplingWifiManager::ThompsonSamplingWifiManager ()
+  : m_currentRate{0}
+{
+  NS_LOG_FUNCTION (this);
+
+  m_gammaRandomVariable = CreateObject<GammaRandomVariable> ();
+}
+
+ThompsonSamplingWifiManager::~ThompsonSamplingWifiManager ()
+{
+  NS_LOG_FUNCTION (this);
+}
+
+WifiRemoteStation *
+ThompsonSamplingWifiManager::DoCreateStation () const
+{
+  NS_LOG_FUNCTION (this);
+  ThompsonSamplingWifiRemoteStation *station = new ThompsonSamplingWifiRemoteStation ();
+  station->m_nextMode = 0;
+  station->m_lastMode = 0;
+  return station;
+}
+
+void
+ThompsonSamplingWifiManager::InitializeStation (WifiRemoteStation *st) const
+{
+  auto station = static_cast<ThompsonSamplingWifiRemoteStation *> (st);
+  if (!station->m_mcsStats.empty ())
+    {
+      return;
+    }
+
+  // Add HT, VHT or HE MCSes
+  for (const auto &mode : GetPhy ()->GetMcsList ())
+    {
+      for (uint16_t j = 20; j <= GetPhy ()->GetChannelWidth (); j *= 2)
+        {
+          WifiModulationClass modulationClass = WIFI_MOD_CLASS_HT;
+          if (GetVhtSupported ())
+            {
+              modulationClass = WIFI_MOD_CLASS_VHT;
+            }
+          if (GetHeSupported ())
+            {
+              modulationClass = WIFI_MOD_CLASS_HE;
+            }
+          if (mode.GetModulationClass () == modulationClass)
+            {
+              for (uint8_t k = 1; k <= GetPhy ()->GetMaxSupportedTxSpatialStreams (); k++)
+                {
+                  if (mode.IsAllowed (j, k))
+                    {
+                      RateStats stats;
+                      stats.mode = mode;
+                      stats.channelWidth = j;
+                      stats.nss = k;
+
+                      station->m_mcsStats.push_back (stats);
+                    }
+                }
+            }
+        }
+    }
+
+  if (station->m_mcsStats.empty ())
+    {
+      // Add legacy non-HT modes.
+      for (uint8_t i = 0; i < GetNSupported (station); i++)
+        {
+          RateStats stats;
+          stats.mode = GetSupported (station, i);
+          if (stats.mode.GetModulationClass () == WIFI_MOD_CLASS_DSSS
+              || stats.mode.GetModulationClass () == WIFI_MOD_CLASS_HR_DSSS)
+            {
+              stats.channelWidth = 22;
+            }
+          else
+            {
+              stats.channelWidth = 20;
+            }
+          stats.nss = 1;
+          station->m_mcsStats.push_back (stats);
+        }
+    }
+
+  NS_ASSERT_MSG (!station->m_mcsStats.empty (), "No usable MCS found");
+
+  UpdateNextMode (st);
+}
+
+void
+ThompsonSamplingWifiManager::DoReportRxOk (WifiRemoteStation *station, double rxSnr, WifiMode txMode)
+{
+  NS_LOG_FUNCTION (this << station << rxSnr << txMode);
+}
+
+void
+ThompsonSamplingWifiManager::DoReportRtsFailed (WifiRemoteStation *station)
+{
+  NS_LOG_FUNCTION (this << station);
+}
+
+void
+ThompsonSamplingWifiManager::DoReportDataFailed (WifiRemoteStation *st)
+{
+  NS_LOG_FUNCTION (this << st);
+  InitializeStation (st);
+  auto station = static_cast<ThompsonSamplingWifiRemoteStation *> (st);
+  Decay (st, station->m_lastMode);
+  station->m_mcsStats.at (station->m_lastMode).fails++;
+  UpdateNextMode (st);
+}
+
+void
+ThompsonSamplingWifiManager::DoReportRtsOk (WifiRemoteStation *st, double ctsSnr, WifiMode ctsMode,
+                                     double rtsSnr)
+{
+  NS_LOG_FUNCTION (this << st << ctsSnr << ctsMode.GetUniqueName () << rtsSnr);
+}
+
+void
+ThompsonSamplingWifiManager::UpdateNextMode (WifiRemoteStation *st) const
+{
+  InitializeStation (st);
+  auto station = static_cast<ThompsonSamplingWifiRemoteStation *> (st);
+
+  double maxThroughput = 0.0;
+  double frameSuccessRate = 1.0;
+
+  NS_ASSERT (!station->m_mcsStats.empty ());
+
+  // Use the most robust MCS if frameSuccessRate is 0 for all MCS.
+  station->m_nextMode = 0;
+
+  for (uint32_t i = 0; i < station->m_mcsStats.size (); i++)
+    {
+      Decay (st, i);
+      const WifiMode mode{station->m_mcsStats.at (i).mode};
+
+      uint16_t guardInterval = GetModeGuardInterval (st, mode);
+      double rate = mode.GetDataRate (station->m_mcsStats.at (i).channelWidth,
+                                      guardInterval,
+                                      station->m_mcsStats.at (i).nss);
+
+      // Thompson sampling
+      frameSuccessRate = SampleBetaVariable (1.0 + station->m_mcsStats.at (i).success,
+                                             1.0 + station->m_mcsStats.at (i).fails);
+      NS_LOG_DEBUG ("Draw"
+                    << " success=" << station->m_mcsStats.at (i).success
+                    << " fails=" << station->m_mcsStats.at (i).fails
+                    << " frameSuccessRate=" << frameSuccessRate
+                    << " mode=" << mode);
+      if (frameSuccessRate * rate > maxThroughput)
+        {
+          maxThroughput = frameSuccessRate * rate;
+          station->m_nextMode = i;
+        }
+    }
+}
+
+void
+ThompsonSamplingWifiManager::DoReportDataOk (WifiRemoteStation *st, double ackSnr, WifiMode ackMode,
+                                      double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss)
+{
+  NS_LOG_FUNCTION (this << st << ackSnr << ackMode.GetUniqueName () << dataSnr);
+  InitializeStation (st);
+  auto station = static_cast<ThompsonSamplingWifiRemoteStation *> (st);
+  Decay (st, station->m_lastMode);
+  station->m_mcsStats.at (station->m_lastMode).success++;
+  UpdateNextMode (st);
+}
+
+void
+ThompsonSamplingWifiManager::DoReportAmpduTxStatus (WifiRemoteStation *st, uint16_t nSuccessfulMpdus,
+                                             uint16_t nFailedMpdus, double rxSnr, double dataSnr,
+                                             uint16_t dataChannelWidth, uint8_t dataNss)
+{
+  NS_LOG_FUNCTION (this << st << nSuccessfulMpdus << nFailedMpdus << rxSnr << dataSnr);
+  InitializeStation (st);
+  auto station = static_cast<ThompsonSamplingWifiRemoteStation *> (st);
+
+  Decay (st, station->m_lastMode);
+  station->m_mcsStats.at (station->m_lastMode).success += nSuccessfulMpdus;
+  station->m_mcsStats.at (station->m_lastMode).fails += nFailedMpdus;
+
+  UpdateNextMode (st);
+}
+
+void
+ThompsonSamplingWifiManager::DoReportFinalRtsFailed (WifiRemoteStation *station)
+{
+  NS_LOG_FUNCTION (this << station);
+}
+
+void
+ThompsonSamplingWifiManager::DoReportFinalDataFailed (WifiRemoteStation *station)
+{
+  NS_LOG_FUNCTION (this << station);
+}
+
+uint16_t
+ThompsonSamplingWifiManager::GetModeGuardInterval (WifiRemoteStation *st, WifiMode mode) const
+{
+  if (mode.GetModulationClass () == WIFI_MOD_CLASS_HE)
+    {
+      return std::max (GetGuardInterval (st), GetGuardInterval ());
+    }
+  else if ((mode.GetModulationClass () == WIFI_MOD_CLASS_HT) ||
+           (mode.GetModulationClass () == WIFI_MOD_CLASS_VHT))
+    {
+      return std::max<uint16_t> (GetShortGuardIntervalSupported (st) ? 400 : 800,
+                                 GetShortGuardIntervalSupported () ? 400 : 800);
+    }
+  else
+    {
+      return 800;
+    }
+}
+
+WifiTxVector
+ThompsonSamplingWifiManager::DoGetDataTxVector (WifiRemoteStation *st)
+{
+  NS_LOG_FUNCTION (this << st);
+  InitializeStation (st);
+  auto station = static_cast<ThompsonSamplingWifiRemoteStation *> (st);
+
+  auto &stats = station->m_mcsStats.at (station->m_nextMode);
+  WifiMode mode = stats.mode;
+  uint16_t channelWidth = std::min (stats.channelWidth, GetPhy ()->GetChannelWidth ());
+  uint8_t nss = stats.nss;
+  uint16_t guardInterval = GetModeGuardInterval (st, mode);
+
+  station->m_lastMode = station->m_nextMode;
+
+  NS_LOG_DEBUG ("Using"
+                << " mode=" << mode
+                << " channelWidth=" << channelWidth
+                << " nss=" << +nss
+                << " guardInterval=" << guardInterval);
+
+  uint64_t rate = mode.GetDataRate (channelWidth, guardInterval, nss);
+  if (m_currentRate != rate)
+    {
+      NS_LOG_DEBUG ("New datarate: " << rate);
+      m_currentRate = rate;
+    }
+
+  return WifiTxVector (
+      mode,
+      GetDefaultTxPowerLevel (),
+      GetPreambleForTransmission (mode.GetModulationClass (),
+                                  GetShortPreambleEnabled ()),
+      GetModeGuardInterval (st, mode),
+      GetNumberOfAntennas (),
+      nss,
+      0, // NESS
+      GetChannelWidthForTransmission (mode, channelWidth),
+      GetAggregation (station),
+      false);
+}
+
+WifiTxVector
+ThompsonSamplingWifiManager::DoGetRtsTxVector (WifiRemoteStation *st)
+{
+  NS_LOG_FUNCTION (this << st);
+  InitializeStation (st);
+  auto station = static_cast<ThompsonSamplingWifiRemoteStation *> (st);
+
+  // Use the most robust MCS for the control channel.
+  auto &stats = station->m_mcsStats.at (0);
+  WifiMode mode = stats.mode;
+  uint16_t channelWidth = std::min (stats.channelWidth, GetPhy ()->GetChannelWidth ());
+  uint8_t nss = stats.nss;
+
+  // Make sure control frames are sent using 1 spatial stream.
+  NS_ASSERT (nss == 1);
+
+  return WifiTxVector (
+      mode, GetDefaultTxPowerLevel (),
+      GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()),
+      GetModeGuardInterval (st, mode),
+      GetNumberOfAntennas (),
+      nss,
+      0, // NESS
+      GetChannelWidthForTransmission (mode, channelWidth),
+      GetAggregation (station),
+      false);
+}
+
+double
+ThompsonSamplingWifiManager::SampleBetaVariable (uint64_t alpha, uint64_t beta) const
+{
+  double X = m_gammaRandomVariable->GetValue (alpha, 1.0);
+  double Y = m_gammaRandomVariable->GetValue (beta, 1.0);
+  return X / (X + Y);
+}
+
+void
+ThompsonSamplingWifiManager::Decay (WifiRemoteStation *st, size_t i) const
+{
+  NS_LOG_FUNCTION (this << st << i);
+  InitializeStation (st);
+  auto station = static_cast<ThompsonSamplingWifiRemoteStation *> (st);
+
+  Time now = Simulator::Now ();
+  auto &stats = station->m_mcsStats.at (i);
+  if (now > stats.lastDecay)
+    {
+      const double coefficient =
+          std::exp (m_decay * (stats.lastDecay - now).GetSeconds ());
+
+      stats.success *= coefficient;
+      stats.fails *= coefficient;
+      stats.lastDecay = now;
+    }
+}
+
+int64_t
+ThompsonSamplingWifiManager::AssignStreams (int64_t stream)
+{
+  NS_LOG_FUNCTION (this << stream);
+  m_gammaRandomVariable->SetStream (stream);
+  return 1;
+}
+
+} //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/rate-control/thompson-sampling-wifi-manager.h ns-3.34/src/wifi/model/rate-control/thompson-sampling-wifi-manager.h
--- ns-3.33/src/wifi/model/rate-control/thompson-sampling-wifi-manager.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/rate-control/thompson-sampling-wifi-manager.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,126 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2021 IITP RAS
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Alexander Krotov <krotov@iitp.ru>
+ */
+
+#ifndef THOMPSON_SAMPLING_WIFI_MANAGER_H
+#define THOMPSON_SAMPLING_WIFI_MANAGER_H
+
+#include "ns3/random-variable-stream.h"
+
+#include "ns3/wifi-remote-station-manager.h"
+
+namespace ns3 {
+
+/**
+ * \brief Thompson Sampling rate control algorithm
+ * \ingroup wifi
+ *
+ * This class implements Thompson Sampling rate control algorithm.
+ *
+ * It was implemented for use as a baseline in
+ * https://doi.org/10.1109/ACCESS.2020.3023552
+ */
+class ThompsonSamplingWifiManager : public WifiRemoteStationManager
+{
+public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+  ThompsonSamplingWifiManager ();
+  virtual ~ThompsonSamplingWifiManager ();
+
+  int64_t AssignStreams (int64_t stream) override;
+
+private:
+  WifiRemoteStation *DoCreateStation () const override;
+  void DoReportRxOk (WifiRemoteStation *station,
+                     double rxSnr, WifiMode txMode) override;
+  void DoReportRtsFailed (WifiRemoteStation *station) override;
+  void DoReportDataFailed (WifiRemoteStation *station) override;
+  void DoReportRtsOk (WifiRemoteStation *station,
+                      double ctsSnr, WifiMode ctsMode, double rtsSnr) override;
+  void DoReportDataOk (WifiRemoteStation *station,
+                       double ackSnr, WifiMode ackMode, double dataSnr,
+                       uint16_t dataChannelWidth, uint8_t dataNss) override;
+  void DoReportAmpduTxStatus (WifiRemoteStation *station,
+                              uint16_t nSuccessfulMpdus, uint16_t nFailedMpdus,
+                              double rxSnr, double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss) override;
+  void DoReportFinalRtsFailed (WifiRemoteStation *station) override;
+  void DoReportFinalDataFailed (WifiRemoteStation *station) override;
+  WifiTxVector DoGetDataTxVector (WifiRemoteStation *station) override;
+  WifiTxVector DoGetRtsTxVector (WifiRemoteStation *station) override;
+
+  /**
+   * Initializes station rate tables. If station is already initialized,
+   * nothing is done.
+   *
+   * \param station Station which should be initialized.
+   */
+  void InitializeStation (WifiRemoteStation *station) const;
+
+  /**
+   * Draws a new MCS and related parameters to try next time for this
+   * station.
+   *
+   * This method should only be called between TXOPs to avoid sending
+   * multiple frames using different modes. Otherwise it is impossible
+   * to tell which mode was used for succeeded/failed frame when
+   * feedback is received.
+   *
+   * \param station Station for which a new mode should be drawn.
+   */
+  void UpdateNextMode (WifiRemoteStation *station) const;
+
+  /**
+   * Applies exponential decay to MCS statistics.
+   *
+   * \param st Remote STA for which MCS statistics is to be updated.
+   * \param i MCS index.
+   */
+  void Decay (WifiRemoteStation *st, size_t i) const;
+
+  /**
+   * Returns guard interval in nanoseconds for the given mode.
+   *
+   * \param st Remote STA.
+   * \param mode The WifiMode.
+   * \return the guard interval in nanoseconds
+   */
+  uint16_t GetModeGuardInterval (WifiRemoteStation *st, WifiMode mode) const;
+
+  /**
+   * Sample beta random variable with given parameters
+   * \param alpha first parameter of beta distribution
+   * \param beta second parameter of beta distribution
+   * \return beta random variable sample
+   */
+  double SampleBetaVariable (uint64_t alpha, uint64_t beta) const;
+
+  Ptr<GammaRandomVariable> m_gammaRandomVariable; //!< Variable used to sample beta-distributed random variables
+
+  double m_decay; //!< Exponential decay coefficient, Hz
+
+  TracedValue<uint64_t> m_currentRate; //!< Trace rate changes
+};
+
+} //namespace ns3
+
+#endif /* THOMPSON_SAMPLING_WIFI_MANAGER_H */
